package com.tyson;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.ComponentScans;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

@SpringBootApplication
@ComponentScans({@ComponentScan("com.tyson.util"),@ComponentScan("com.tyson.consts")})
@EnableAsync
@EnableScheduling
public class TysonapiApplication {

    public static void main(String[] args) {
        SpringApplication.run(TysonapiApplication.class, args);
        System.out.println("--------------启动成功--------------");

    }

}
