package com.tyson.controller;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.HashMap;

import com.tyson.util.dingUtil;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RestController;

@Component
public class ReadExcel {

    @Autowired
    private dingUtil dingUtil;

    public void readExcel(String path) {
        try {
            //创建工作簿对象
            XSSFWorkbook xssfWorkbook = new XSSFWorkbook(new FileInputStream(path));
            //读取第i个工作表
            XSSFSheet sheet = xssfWorkbook.getSheetAt(0);
            //获取最后一行的num，即总行数。此处从0开始
            int maxRow = sheet.getLastRowNum();
            System.out.println(maxRow);
            HashMap<String, String> map = new HashMap<>();
            for (int row = 0; row <= maxRow; row++) {
                sheet.getRow(row).getCell(0).setCellType(CellType.STRING);
                String key = sheet.getRow(row).getCell(0).getStringCellValue();
                String value = sheet.getRow(row).getCell(1).getStringCellValue();
                map.put(key, value);
            }
            JSONArray objects = new JSONArray();

            for (String key : map.keySet()) {
                String value = map.get(key);

                JSONObject jsonObject = new JSONObject();
                jsonObject.put("textField_l75terja", value);
                jsonObject.put("textField_l75terjb", key);
                JSONArray jsonArray = new JSONArray();
                try {
                    jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-EX866CB143A3WF6PAR7O94M7SE7I2FMKET57L5", jsonObject));
                } catch (Exception ex) {

                }
                try {
                    if (jsonArray.length() > 0) {
                        String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                        dingUtil.UpdateYiDa(formInstanceId, jsonObject);
                    } else {
                        dingUtil.saveYiDa("FORM-EX866CB143A3WF6PAR7O94M7SE7I2FMKET57L5", jsonObject, "01021447385039757257");
                    }
                } catch (Exception ex) {
                    objects.put(jsonObject);
                    continue;
                }
            }
            while (true) {
                JSONArray objects2 = new JSONArray();
                for (int i = 0; i < objects.length(); i++) {
                    JSONObject jsonObject = objects.getJSONObject(i);
                    JSONArray jsonArray = new JSONArray();
                    try {
                        jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-EX866CB143A3WF6PAR7O94M7SE7I2FMKET57L5", jsonObject));
                    } catch (Exception ex) {

                    }
                    try {
                        if (jsonArray.length() > 0) {
                            String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                            dingUtil.UpdateYiDa(formInstanceId, jsonObject);
                        } else {
                            dingUtil.saveYiDa("FORM-EX866CB143A3WF6PAR7O94M7SE7I2FMKET57L5", jsonObject, "01021447385039757257");
                        }
                    } catch (Exception ex) {
                        objects2.put(jsonObject);
                        continue;
                    }
                }
                objects = new JSONArray();
                for (int i = 0; i < objects2.length(); i++) {
                    JSONObject jsonObject = objects2.getJSONObject(i);
                    JSONArray jsonArray = new JSONArray();
                    try {
                        jsonArray = new JSONArray(dingUtil.yiDaSearch("FORM-EX866CB143A3WF6PAR7O94M7SE7I2FMKET57L5", jsonObject));
                    } catch (Exception ex) {

                    }
                    try {
                        if (jsonArray.length() > 0) {
                            String formInstanceId = jsonArray.getJSONObject(0).getString("formInstanceId");
                            dingUtil.UpdateYiDa(formInstanceId, jsonObject);
                        } else {
                            dingUtil.saveYiDa("FORM-EX866CB143A3WF6PAR7O94M7SE7I2FMKET57L5", jsonObject, "01021447385039757257");
                        }
                    } catch (Exception ex) {
                        objects.put(jsonObject);
                        continue;
                    }
                }
                if(objects.length() == 0){
                    break;
                }
            }
            System.out.println("成功");
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Exception exception) {
            exception.printStackTrace();
        }

    }

}

