package com.tyson.tysonapi;


import com.alibaba.fastjson.JSON;
//import com.sun.org.apache.regexp.internal.RE;
import com.tyson.util.CusutUtil;
import com.tyson.util.dingUtil;
import com.tyson.util.sendEmail;
import com.tyson.vo.DeductionVo;
import lombok.extern.slf4j.Slf4j;
import org.json.JSONArray;
import org.json.JSONObject;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Date;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

@SpringBootTest
@Slf4j
class TysonapiApplicationTests {

    @Autowired
    private dingUtil dingUtil;

    @Test
    void contextLoads() {
        long l = CusutUtil.dateTOtimeshap("2022年07月19日");
        System.out.println(l);
//
//        String filename = "file.txt";// 文件名
//        String[] strArray = filename.split(".");
//        int suffixIndex = strArray.length -1;
//        System.out.println(strArray[suffixIndex]);

        String fileName = "E:\file.doc";
        String fileTyle = fileName.substring(fileName.lastIndexOf(".") + 1, fileName.length());
        System.out.println(fileTyle);
        //1660621567

        String sl = "13%";
        double substring = Double.parseDouble(sl.substring(0, sl.lastIndexOf("%"))) / 100;
        System.out.println(substring);
    }

    @Test
    public void Demo() {
        String dateStr1 = "2023年12月08日";
        String dateStr2 = "2023年12月03日";
        String dateStr3 = "2023年10月03日";
        // 创建一个日期格式器，与给定字符串的格式匹配
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy年MM月dd日");

        // 使用格式器解析字符串为LocalDate对象
        List<LocalDate> list = new ArrayList<>();
        LocalDate date1 = LocalDate.parse(dateStr1, formatter);
        LocalDate date2 = LocalDate.parse(dateStr2, formatter);
        LocalDate date3 = LocalDate.parse(dateStr3, formatter);

        list.add(date1);
        list.add(date2);
        list.add(date3);
        list.forEach(System.out::println);
        List<LocalDate> sortDates = list.stream().sorted().collect(Collectors.toList());

        // 打印转换后的日期
        // 打印排序后的日期列表
        sortDates.forEach(System.out::println);

    }


    @Test
    void test2() {
        try {
            String t = "[{\"formType\":\"receipt\",\"formUuid\":\"FORM-VJ866081OT35UBK5761GA5RJE2BK3DAZDDS9LB\",\"instanceId\":\"FINST-1J666IA1KJYGV0UH8VWY560KSFG72GNTPGDQLU8\",\"subTitle\":\"\",\"appType\":\"APP_N9NPHVTQLPBPO8MR6WFG\",\"title\":\"\"},{\"formType\":\"receipt\",\"formUuid\":\"FORM-VJ866081OT35UBK5761GA5RJE2BK3DAZDDS9LB\",\"instanceId\":\"FINST-R7766ZB1CP4HLILTASN3Z6AJ5CA139AAP2PQLJU\",\"subTitle\":\"\",\"appType\":\"APP_N9NPHVTQLPBPO8MR6WFG\",\"title\":\"\"}]";

            String a = "\"[{\\\"formType\\\":\\\"receipt\\\",\\\"formUuid\\\":\\\"FORM-VJ866081OT35UBK5761GA5RJE2BK3DAZDDS9LB\\\",\\\"instanceId\\\":\\\"FINST-1J666IA12N4HGN1HDFWTF741C8FX297BZ1MQL74\\\",\\\"subTitle\\\":\\\"\\\",\\\"appType\\\":\\\"APP_N9NPHVTQLPBPO8MR6WFG\\\",\\\"title\\\":\\\"上海市闵行区外商投资协会\\\"},{\\\"formType\\\":\\\"receipt\\\",\\\"formUuid\\\":\\\"FORM-VJ866081OT35UBK5761GA5RJE2BK3DAZDDS9LB\\\",\\\"instanceId\\\":\\\"FINST-5Q666MB1LQ4HY8NQD7L1V6ZBOAUJ2HG6JXOQL7T\\\",\\\"subTitle\\\":\\\"\\\",\\\"appType\\\":\\\"APP_N9NPHVTQLPBPO8MR6WFG\\\",\\\"title\\\":\\\"上海市闵行区外商投资协会\\\"},{\\\"formType\\\":\\\"receipt\\\",\\\"formUuid\\\":\\\"FORM-VJ866081OT35UBK5761GA5RJE2BK3DAZDDS9LB\\\",\\\"instanceId\\\":\\\"FINST-2D6665A1AJYGPXOIA0QQWDBZ5L9J298FABGQLZF\\\",\\\"subTitle\\\":\\\"\\\",\\\"appType\\\":\\\"APP_N9NPHVTQLPBPO8MR6WFG\\\",\\\"title\\\":\\\"上海市闵行区外商投资协会\\\"}]\"";

            BigDecimal reduceMoney = new BigDecimal("32000");

            //JSON
            JSONArray jsonArray = new JSONArray(t);
            //DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy年MM月dd日");
            //DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd-");
            List<DeductionVo> list = new ArrayList<>();

            for (Object obj : jsonArray) {

                JSONObject jsonObject = new JSONObject(obj.toString());
                String instanceIdStr = (String) jsonObject.get("instanceId");
                log.info("instanceId : {}", instanceIdStr);


                String yidaByIdStr = dingUtil.getYidaById(instanceIdStr);
                log.info(yidaByIdStr);
                JSONObject jsonObj = new JSONObject(yidaByIdStr);
                Long timestamp = jsonObj.getLong("dateField_l9nsavm3");

                // 将毫秒时间戳转换为Instant对象
                Instant instant = Instant.ofEpochMilli(timestamp);

                // 根据系统默认时区将Instant对象转换为LocalDateTime
                LocalDateTime localDateTime = instant.atZone(ZoneId.systemDefault()).toLocalDateTime();

                // 从LocalDateTime获取LocalDate
                LocalDate date = localDateTime.toLocalDate();


                BigDecimal pay = jsonObj.getBigDecimal("numberField_l9nwaike");

                DeductionVo deductionVo = new DeductionVo();
                deductionVo.setId(instanceIdStr);
                deductionVo.setDate(date);
                deductionVo.setMoney(pay);

                list.add(deductionVo);
            }
            // 排序
            List<DeductionVo> sortList = list.stream().sorted(Comparator.comparing(DeductionVo::getDate)).collect(Collectors.toList());


            // 按照顺序扣减
            for (DeductionVo deductionVo : sortList) {

                BigDecimal money = deductionVo.getMoney();
                int code = reduceMoney.compareTo(money);

                if (code >= 0) {
                    // reduceMoney 大
                    reduceMoney = reduceMoney.subtract(money);
                    deductionVo.setMoney(BigDecimal.ZERO);
                } else {
                    deductionVo.setMoney(money.subtract(reduceMoney));
                    reduceMoney = BigDecimal.ZERO;
                    break;
                }
            }

            for (DeductionVo deductionVo : sortList) {
                String id = deductionVo.getId();
                String yidaByIdStr = dingUtil.getYidaById(id);
                JSONObject jsonObj = new JSONObject(yidaByIdStr);
                jsonObj.put("numberField_l9nwaike", deductionVo.getMoney());

                log.info("jsonObj:{}",jsonObj);
                dingUtil.UpdateYiDa(id, jsonObj);

            }

        } catch (Exception e) {
            e.printStackTrace();
        }


    }


    @Test
    void test1() {
        String post = "{\n" +
                "\t\"code\":\"0001\",\n" +
                "\t\"data\":[],\n" +
                "\t\"msg\":\"\\u5B58\\u5728\\u51ED\\u8BC1\\u672A\\u4F20\\u5165\\u53D1\\u7968\\u6570\\u636E\\uFF01\"\n" +
                "}";

        String t = "[{\"formType\":\"receipt\",\"formUuid\":\"FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51\",\"instanceId\":\"FINST-NGA66WA19E5E4DP48KG868MUXA853POHTNEMLYI3\",\"subTitle\":\"\",\"appType\":\"APP_N9NPHVTQLPBPO8MR6WFG\",\"title\":\"\"},{\"formType\":\"receipt\",\"formUuid\":\"FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51\",\"instanceId\":\"FINST-BL866S613W4EKPR7BOEYK4MWVYL63GTGTNEMLGV7\",\"subTitle\":\"\",\"appType\":\"APP_N9NPHVTQLPBPO8MR6WFG\",\"title\":\"\"},{\"formType\":\"receipt\",\"formUuid\":\"FORM-4J7669A1Z1X22RIL61LB7AOXGRX82OHP45U6L51\",\"instanceId\":\"FINST-Z6966NB1IW4EY2FV7F5G076IJVRP2LY3QLEMLLLC\",\"subTitle\":\"\",\"appType\":\"APP_N9NPHVTQLPBPO8MR6WFG\",\"title\":\"\"}]";

        //JSON
        JSONArray objects = new JSONArray(t);


        String sp = "},";
        String T1 = t.substring(1, t.length() - 1);
        String[] ts = T1.split(sp);
        for (String substring : ts) {
            substring = "[" + substring + "}]";
            String substring1 = substring.substring(0, substring.length() - 1);

            String instanceId = new JSONArray(substring1).getJSONObject(0).getString("instanceId");

        }
        String urlEncoderString = URLDecoderString(post);
        String s = URLDecoderString(post);

        System.out.println(unicodeDecode(s));

        try {
            String s2 = new String(s.getBytes("ISO-8859-1"), "GBK");

            String str = new String(s2.getBytes("ISO-8859-1"), "UTF-8");
            System.out.println(s2);

        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }


    }

    /**
     * @param string
     * @return 转换之后的内容
     * @Title: unicodeDecode
     * @Description: unicode解码 将Unicode的编码转换为中文
     */
    public String unicodeDecode(String string) {
        Pattern pattern = Pattern.compile("(\\\\u(\\p{XDigit}{4}))");
        Matcher matcher = pattern.matcher(string);
        char ch;
        while (matcher.find()) {
            ch = (char) Integer.parseInt(matcher.group(2), 16);
            string = string.replace(matcher.group(1), ch + "");
        }
        return string;
    }

    public String getURLEncoderString(String str) {
        String result = "";
        if (null == str) {
            return "";
        }
        try {
            result = java.net.URLEncoder.encode(str, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return result;
    }

    public String URLDecoderString(String str) {
        String result = "";
        if (null == str) {
            return "";
        }
        try {
            result = java.net.URLDecoder.decode(str, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return result;
    }

    @Test
    void test3() {
        String str = (100000 + 2 + 1) + "";

        System.out.println("2022-PO202212" + str.substring(1, str.length()));
    }

    @Test
    void test4() {
        String str = "2022";

        System.out.println(str.substring(2, 4));
    }

    @Test
    void tst5() {
        String kgxrgz = "20220930";
        String kprq = "20221010";

        String nowDate = CusutUtil.getNowDate();
        System.out.println(nowDate);

    }

    @Test
    void tst6() {
        int sj = -4;
        int sj2 = -5;
        int sj3 = -6;
        int sj4 = 10;
        System.out.println(sj < sj2);
        System.out.println(sj3 < sj2);
        System.out.println(sj4 < sj2);
    }


    @Test
    void test7() {
        JSONObject cobj = new JSONObject();
//        cobj.put("textField_l8jygtyf","");
        long cdata = 0l;
        try {
            cdata = dingUtil.yiDaSearch2("FORM-3J866L819YI3M8ND7DFPSBLD6OP93J9M1AH7L3", cobj);
        } catch (Exception exception) {
            exception.printStackTrace();
        }
        if (cdata > 1) {
            System.out.println(100000 + cdata);
//                    String str = (100000 + data.length() + 1) + "";
//                    upJson.put("textField_l8jygtyf",);
//            object.remove("textField_l8jygtyf");
//            object.put("textField_l8jygtyf", upJson.getString("textField_l8jygtyf"));
        }
    }

    @Test
    void test8() {
        String e_belnr = "192000015;660000000";
        if (e_belnr.contains(";")) {
            String[] split = e_belnr.split(";");
            e_belnr = split[0] + ";";
            System.out.println(e_belnr);
        }
    }

    @Test
    void test6() {
//        try {
//            String kgxrgz = "20230430";
//            String kprq = "20230504";
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
//            try {
//                Date kgxrgz_date = sdf.parse(kgxrgz);
//                Date kprq_date = sdf.parse(kprq);
//                System.out.println(kgxrgz_date.compareTo(kprq_date));
//                if (kgxrgz_date.compareTo(kprq_date) < 0) {
//                    System.out.println("超过");
//                }
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        } catch (Exception ex) {
//
//        }
        try {
            //
//            String post = "2023-07-28 21:53:48.116  INFO 2856 --- [nio-8020-exec-1] o.a.c.c.C.[Tomcat].[localhost].[/]       : Initializing Spring DispatcherServlet 'dispatcherServlet'\n" +
//                    "2023-07-28 21:53:48.117  INFO 2856 --- [nio-8020-exec-1] o.s.web.servlet.DispatcherServlet        : Initializing Servlet 'dispatcherServlet'\n" +
//                    "2023-07-28 21:53:48.117  INFO 2856 --- [nio-8020-exec-1] o.s.web.servlet.DispatcherServlet        : Completed initialization in 0 ms\n" +
//                    "{\n" +
//                    "\t\"code\":\"0000\",\n" +
//                    "\t\"data\":[\n" +
//                    "\t\t{\n" +
//                    "\t\t\t\"invoicecode\":\"49195656\",\n" +
//                    "\t\t\t\"invoicenumber\":\"3200224130\",\n" +
//                    "\t\t\t\"returncode\":\"0\",\n" +
//                    "\t\t\t\"returnmsg\":\"\\u672A\\u540C\\u6B65\\u5230\\u8BE5\\u53D1\\u7968\\u4FE1\\u606F\\uFF0C\\u8BF7\\u5148\\u8FDB\\u884C\\u540C\\u6B65\\u53D1\\u7968\\u64CD\\u4F5C\\uFF01\"\n" +
//                    "\t\t}\n" +
//                    "\t],\n" +
//                    "\t\"msg\":\"\\u7533\\u8BF7\\u5B8C\\u6210\\uFF01\"\n" +
//                    "}\n";
//            System.out.println(CusutUtil.unicodeDecode(post));
            String fileName = "This is my file.txt";
            String path = File.separator.toCharArray()[0] + "home" + File.separator + "myUsername" + File.separator + "folder" + File.separator;
            String filePath = path + fileName;
            System.out.println();
//            sendEmail.sendmail("2987894992@qq.com","测试","111");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

// bookkeepingJArray = new JSONArray("[\n" +
//                    "    {\n" +
//                    "        \"voucherstatus\": \"0\",\n" +
//                    "        \"syssource\": \"第三方系统规定\",\n" +
//                    "        \"bookeepflag\": \"1\",\n" +
//                    "        \"invoices\": [\n" +
//                    "            {\n" +
//                    "                \"taxrate\": 2.28,\n" +
//                    "                \"oper\": \"0\",\n" +
//                    "                \"autodeduct\": \"1\",\n" +
//                    "                \"taxno\": \"91440300618806911D\",\n" +
//                    "                \"invoicecode\": \"49195656\",\n" +
//                    "                \"invoicenumber\": \"3200224130\",\n" +
//                    "                \"usetax\": \"2.28\"\n" +
//                    "            },\n" +
//                    "            {\n" +
//                    "                \"taxrate\": 0.01,\n" +
//                    "                \"oper\": \"0\",\n" +
//                    "                \"autodeduct\": \"1\",\n" +
//                    "                \"taxno\": \"91440300618806911D\",\n" +
//                    "                \"invoicecode\": \"全电发票\",\n" +
//                    "                \"invoicenumber\": \"23312000000037360346\",\n" +
//                    "                \"usetax\": \"21.91\"\n" +
//                    "            },\n" +
//                    "            {\n" +
//                    "                \"taxrate\": 0.01,\n" +
//                    "                \"oper\": \"0\",\n" +
//                    "                \"autodeduct\": \"1\",\n" +
//                    "                \"taxno\": \"91440300618806911D\",\n" +
//                    "                \"invoicecode\": \"全电发票\",\n" +
//                    "                \"invoicenumber\": \"23922000000009491809\",\n" +
//                    "                \"usetax\": \"12.34\"\n" +
//                    "            },\n" +
//                    "            {\n" +
//                    "                \"taxrate\": 0.01,\n" +
//                    "                \"oper\": \"0\",\n" +
//                    "                \"autodeduct\": \"1\",\n" +
//                    "                \"taxno\": \"91440300618806911D\",\n" +
//                    "                \"invoicecode\": \"3700224130\",\n" +
//                    "                \"invoicenumber\": \"12514578\",\n" +
//                    "                \"usetax\": \"78.45\"\n" +
//                    "            }\n" +
//                    "        ],\n" +
//                    "        \"voucherdate\": \"2023-06-21 00:00:00\",\n" +
//                    "        \"vouchernumber\": \"1930000012\",\n" +
//                    "        \"applytime\": \"2023-06-21 00:00:00\"\n" +
//                    "    }\n" +
//                    "]");