package com.tyson.controller;

import com.tyson.consts.dingConst;
import com.tyson.util.CusutUtil;
import com.tyson.util.dingUtil;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * Decription:
 *
 * @author hzk
 * @ClassName YiDaController
 * @Date 2022/8/3 11:41
 */
@RestController
@RequestMapping("/time")
public class timeController {

    @Autowired
    private dingUtil dingUtil;

    @Autowired
    private YiDaController yiDaController;

    @Scheduled(fixedDelayString = "1800000") //上一次执行完毕时间点之后半小时再执行
    public void test() {
        try {
            System.out.println("验真定时器2023-0725"+CusutUtil.getNowDate());
            yiDaController.test("异常");
            yiDaController.test("失败");

        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }


}
